/**
 * License Agreement.
 *
 * Ajax4jsf 1.1 - Natural Ajax for Java Server Faces (JSF)
 *
 * Copyright (C) 2007 Exadel, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

package org.richfaces.component.html;

import java.lang.String ;
import java.lang.Object ;
import javax.faces.el.MethodBinding ;
import org.richfaces.component.UIDragSupport ;

import javax.faces.context.FacesContext;
import javax.faces.el.ValueBinding;

/**
 * Component-Type org.richfaces.DragSupport
 * Component-Family org.richfaces.DragSupport
  	 * Renderer-Type org.richfaces.DragSupportRenderer
  	 * 
 */
 public class HtmlDragSupport extends org.richfaces.component.UIDragSupport {

  public static final String COMPONENT_TYPE = "org.richfaces.DragSupport";

  /**
   *  Constructor to init default renderers 
   */ 
  public HtmlDragSupport (){
  	  	setRendererType("org.richfaces.DragSupportRenderer");
  	  }

// Component properties fields
  	/**
	 * dragValue
	 * Data to be sent to the drop zone after a drop event.
	 */
	 	 private Object  _dragValue = null; /* Default is null*/
	 	  	/**
	 * ondragend
	 * A JavaScript event handler called after a drag operation.
	 */
	 	 private String  _ondragend = null; /* Default is null*/
	 	    	/**
	 * oncomplete
	 * oncomplete
	 */
	 	 private String  _oncomplete = null; /* Default is null*/
	 	   	/**
	 * reRender
	 * reRender
	 */
	 	 private Object  _reRender = null; /* Default is null*/
	 	   	/**
	 * disableDefault
	 * disableDefault
	 */
	 	 private boolean  _disableDefault = false;		
	/**
	 * Flag indicated what disableDefault is set.
	 */
	 private boolean _disableDefaultSet = false;	
	 	  	/**
	 * bypassUpdates
	 * bypassUpdates
	 */
	 	 private boolean  _bypassUpdates = false;		
	/**
	 * Flag indicated what bypassUpdates is set.
	 */
	 private boolean _bypassUpdatesSet = false;	
	 	  	/**
	 * limitToList
	 * limitToList
	 */
	 	 private boolean  _limitToList = false;		
	/**
	 * Flag indicated what limitToList is set.
	 */
	 private boolean _limitToListSet = false;	
	 	  	/**
	 * ajaxSingle
	 * ajaxSingle
	 */
	 	 private boolean  _ajaxSingle = false;		
	/**
	 * Flag indicated what ajaxSingle is set.
	 */
	 private boolean _ajaxSingleSet = false;	
	 	  	/**
	 * onsubmit
	 * onsubmit
	 */
	 	 private String  _onsubmit = null; /* Default is null*/
	 	  	/**
	 * dragIndicator
	 * Id of the dragIndicator component used as drag operation cursor.
	 */
	 	 private String  _dragIndicator = null; /* Default is null*/
	 	     	/**
	 * dragListener
	 * dragListener
	 */
	 	 private MethodBinding  _dragListener = null; /* Default is null*/
	 	  	/**
	 * timeout
	 * timeout
	 */
	 	 private int  _timeout = Integer.MIN_VALUE;		
	/**
	 * Flag indicated what timeout is set.
	 */
	 private boolean _timeoutSet = false;	
	 	   	/**
	 * dragType
	 * Key of a drag object. It's used to define a necessity of processing the current dragged element on the drop zone side
	 */
	 	 private String  _dragType = null; /* Default is null*/
	 	  	/**
	 * status
	 * status
	 */
	 	 private String  _status = null; /* Default is null*/
	 	   	/**
	 * requestDelay
	 * requestDelay
	 */
	 	 private int  _requestDelay = Integer.MIN_VALUE;		
	/**
	 * Flag indicated what requestDelay is set.
	 */
	 private boolean _requestDelaySet = false;	
	 	  	/**
	 * eventsQueue
	 * eventsQueue
	 */
	 	 private String  _eventsQueue = null; /* Default is null*/
	 	   	/**
	 * data
	 * data
	 */
	 	 private Object  _data = null; /* Default is null*/
	 	   	/**
	 * ondragstart
	 * A JavaScript event handler called before drag object.
	 */
	 	 private String  _ondragstart = null; /* Default is null*/
	 	   	/**
	 * ignoreDupResponses
	 * ignoreDupResponses
	 */
	 	 private boolean  _ignoreDupResponses = false;		
	/**
	 * Flag indicated what ignoreDupResponses is set.
	 */
	 private boolean _ignoreDupResponsesSet = false;	
	 	 
// Getters-setters
  	/*
	 * Data to be sent to the drop zone after a drop event.
	 * Setter for dragValue
	 * @param dragValue - new value
	 */
	 public void setDragValue( Object  __dragValue ){
		this._dragValue = __dragValue;
	 	 }


	/*
	 * Data to be sent to the drop zone after a drop event.
	 * Getter for dragValue
	 * @return dragValue value from local variable or value bindings
	 */
	 public Object getDragValue(  ){
	         if (null != this._dragValue)
        {
            return this._dragValue;
        	    }
        ValueBinding vb = getValueBinding("dragValue");
        if (null != vb){
            return (Object)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	   	/*
	 * A JavaScript event handler called after a drag operation.
	 * Setter for ondragend
	 * @param ondragend - new value
	 */
	 public void setOndragend( String  __ondragend ){
		this._ondragend = __ondragend;
	 	 }


	/*
	 * A JavaScript event handler called after a drag operation.
	 * Getter for ondragend
	 * @return ondragend value from local variable or value bindings
	 */
	 public String getOndragend(  ){
	         if (null != this._ondragend)
        {
            return this._ondragend;
        	    }
        ValueBinding vb = getValueBinding("ondragend");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	     	/*
	 * oncomplete
	 * Setter for oncomplete
	 * @param oncomplete - new value
	 */
	 public void setOncomplete( String  __oncomplete ){
		this._oncomplete = __oncomplete;
	 	 }


	/*
	 * oncomplete
	 * Getter for oncomplete
	 * @return oncomplete value from local variable or value bindings
	 */
	 public String getOncomplete(  ){
	         if (null != this._oncomplete)
        {
            return this._oncomplete;
        	    }
        ValueBinding vb = getValueBinding("oncomplete");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	    	/*
	 * reRender
	 * Setter for reRender
	 * @param reRender - new value
	 */
	 public void setReRender( Object  __reRender ){
		this._reRender = __reRender;
	 	 }


	/*
	 * reRender
	 * Getter for reRender
	 * @return reRender value from local variable or value bindings
	 */
	 public Object getReRender(  ){
	         if (null != this._reRender)
        {
            return this._reRender;
        	    }
        ValueBinding vb = getValueBinding("reRender");
        if (null != vb){
            return (Object)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	    	/*
	 * disableDefault
	 * Setter for disableDefault
	 * @param disableDefault - new value
	 */
	 public void setDisableDefault( boolean  __disableDefault ){
		this._disableDefault = __disableDefault;
	 		this._disableDefaultSet = true;
	 	 }


	/*
	 * disableDefault
	 * Getter for disableDefault
	 * @return disableDefault value from local variable or value bindings
	 */
	 public boolean isDisableDefault(  ){
	 		 if(this._disableDefaultSet){
			return this._disableDefault;
		 }
    	ValueBinding vb = getValueBinding("disableDefault");
    	if (vb != null) {
    	    Boolean value = (Boolean) vb.getValue(getFacesContext());
    	    if (null == value) {
    			return this._disableDefault;
    	    }
    	    return (value.booleanValue());
    	} else {
    	    return (this._disableDefault);
    	}
	 	 }
	   	/*
	 * bypassUpdates
	 * Setter for bypassUpdates
	 * @param bypassUpdates - new value
	 */
	 public void setBypassUpdates( boolean  __bypassUpdates ){
		this._bypassUpdates = __bypassUpdates;
	 		this._bypassUpdatesSet = true;
	 	 }


	/*
	 * bypassUpdates
	 * Getter for bypassUpdates
	 * @return bypassUpdates value from local variable or value bindings
	 */
	 public boolean isBypassUpdates(  ){
	 		 if(this._bypassUpdatesSet){
			return this._bypassUpdates;
		 }
    	ValueBinding vb = getValueBinding("bypassUpdates");
    	if (vb != null) {
    	    Boolean value = (Boolean) vb.getValue(getFacesContext());
    	    if (null == value) {
    			return this._bypassUpdates;
    	    }
    	    return (value.booleanValue());
    	} else {
    	    return (this._bypassUpdates);
    	}
	 	 }
	   	/*
	 * limitToList
	 * Setter for limitToList
	 * @param limitToList - new value
	 */
	 public void setLimitToList( boolean  __limitToList ){
		this._limitToList = __limitToList;
	 		this._limitToListSet = true;
	 	 }


	/*
	 * limitToList
	 * Getter for limitToList
	 * @return limitToList value from local variable or value bindings
	 */
	 public boolean isLimitToList(  ){
	 		 if(this._limitToListSet){
			return this._limitToList;
		 }
    	ValueBinding vb = getValueBinding("limitToList");
    	if (vb != null) {
    	    Boolean value = (Boolean) vb.getValue(getFacesContext());
    	    if (null == value) {
    			return this._limitToList;
    	    }
    	    return (value.booleanValue());
    	} else {
    	    return (this._limitToList);
    	}
	 	 }
	   	/*
	 * ajaxSingle
	 * Setter for ajaxSingle
	 * @param ajaxSingle - new value
	 */
	 public void setAjaxSingle( boolean  __ajaxSingle ){
		this._ajaxSingle = __ajaxSingle;
	 		this._ajaxSingleSet = true;
	 	 }


	/*
	 * ajaxSingle
	 * Getter for ajaxSingle
	 * @return ajaxSingle value from local variable or value bindings
	 */
	 public boolean isAjaxSingle(  ){
	 		 if(this._ajaxSingleSet){
			return this._ajaxSingle;
		 }
    	ValueBinding vb = getValueBinding("ajaxSingle");
    	if (vb != null) {
    	    Boolean value = (Boolean) vb.getValue(getFacesContext());
    	    if (null == value) {
    			return this._ajaxSingle;
    	    }
    	    return (value.booleanValue());
    	} else {
    	    return (this._ajaxSingle);
    	}
	 	 }
	   	/*
	 * onsubmit
	 * Setter for onsubmit
	 * @param onsubmit - new value
	 */
	 public void setOnsubmit( String  __onsubmit ){
		this._onsubmit = __onsubmit;
	 	 }


	/*
	 * onsubmit
	 * Getter for onsubmit
	 * @return onsubmit value from local variable or value bindings
	 */
	 public String getOnsubmit(  ){
	         if (null != this._onsubmit)
        {
            return this._onsubmit;
        	    }
        ValueBinding vb = getValueBinding("onsubmit");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	   	/*
	 * Id of the dragIndicator component used as drag operation cursor.
	 * Setter for dragIndicator
	 * @param dragIndicator - new value
	 */
	 public void setDragIndicator( String  __dragIndicator ){
		this._dragIndicator = __dragIndicator;
	 	 }


	/*
	 * Id of the dragIndicator component used as drag operation cursor.
	 * Getter for dragIndicator
	 * @return dragIndicator value from local variable or value bindings
	 */
	 public String getDragIndicator(  ){
	         if (null != this._dragIndicator)
        {
            return this._dragIndicator;
        	    }
        ValueBinding vb = getValueBinding("dragIndicator");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	      	/*
	 * dragListener
	 * Setter for dragListener
	 * @param dragListener - new value
	 */
	 public void setDragListener( MethodBinding  __dragListener ){
		this._dragListener = __dragListener;
	 	 }


	/*
	 * dragListener
	 * Getter for dragListener
	 * @return dragListener value from local variable or value bindings
	 */
	 public MethodBinding getDragListener(  ){
	         if (null != this._dragListener)
        {
            return this._dragListener;
                } else {
            return null;
        }
	 	 }
	   	/*
	 * timeout
	 * Setter for timeout
	 * @param timeout - new value
	 */
	 public void setTimeout( int  __timeout ){
		this._timeout = __timeout;
	 		this._timeoutSet = true;
	 	 }


	/*
	 * timeout
	 * Getter for timeout
	 * @return timeout value from local variable or value bindings
	 */
	 public int getTimeout(  ){
	 		 if(this._timeoutSet){
			return this._timeout;
		 }
    	ValueBinding vb = getValueBinding("timeout");
    	if (vb != null) {
    	    Integer value = (Integer) vb.getValue(getFacesContext());
    	    if (null == value) {
    			return this._timeout;
    	    }
    	    return (value.intValue());
    	} else {
    	    return (this._timeout);
    	}
	 	 }
	    	/*
	 * Key of a drag object. It's used to define a necessity of processing the current dragged element on the drop zone side
	 * Setter for dragType
	 * @param dragType - new value
	 */
	 public void setDragType( String  __dragType ){
		this._dragType = __dragType;
	 	 }


	/*
	 * Key of a drag object. It's used to define a necessity of processing the current dragged element on the drop zone side
	 * Getter for dragType
	 * @return dragType value from local variable or value bindings
	 */
	 public String getDragType(  ){
	         if (null != this._dragType)
        {
            return this._dragType;
        	    }
        ValueBinding vb = getValueBinding("dragType");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	   	/*
	 * status
	 * Setter for status
	 * @param status - new value
	 */
	 public void setStatus( String  __status ){
		this._status = __status;
	 	 }


	/*
	 * status
	 * Getter for status
	 * @return status value from local variable or value bindings
	 */
	 public String getStatus(  ){
	         if (null != this._status)
        {
            return this._status;
        	    }
        ValueBinding vb = getValueBinding("status");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	    	/*
	 * requestDelay
	 * Setter for requestDelay
	 * @param requestDelay - new value
	 */
	 public void setRequestDelay( int  __requestDelay ){
		this._requestDelay = __requestDelay;
	 		this._requestDelaySet = true;
	 	 }


	/*
	 * requestDelay
	 * Getter for requestDelay
	 * @return requestDelay value from local variable or value bindings
	 */
	 public int getRequestDelay(  ){
	 		 if(this._requestDelaySet){
			return this._requestDelay;
		 }
    	ValueBinding vb = getValueBinding("requestDelay");
    	if (vb != null) {
    	    Integer value = (Integer) vb.getValue(getFacesContext());
    	    if (null == value) {
    			return this._requestDelay;
    	    }
    	    return (value.intValue());
    	} else {
    	    return (this._requestDelay);
    	}
	 	 }
	   	/*
	 * eventsQueue
	 * Setter for eventsQueue
	 * @param eventsQueue - new value
	 */
	 public void setEventsQueue( String  __eventsQueue ){
		this._eventsQueue = __eventsQueue;
	 	 }


	/*
	 * eventsQueue
	 * Getter for eventsQueue
	 * @return eventsQueue value from local variable or value bindings
	 */
	 public String getEventsQueue(  ){
	         if (null != this._eventsQueue)
        {
            return this._eventsQueue;
        	    }
        ValueBinding vb = getValueBinding("eventsQueue");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	    	/*
	 * data
	 * Setter for data
	 * @param data - new value
	 */
	 public void setData( Object  __data ){
		this._data = __data;
	 	 }


	/*
	 * data
	 * Getter for data
	 * @return data value from local variable or value bindings
	 */
	 public Object getData(  ){
	         if (null != this._data)
        {
            return this._data;
        	    }
        ValueBinding vb = getValueBinding("data");
        if (null != vb){
            return (Object)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	    	/*
	 * A JavaScript event handler called before drag object.
	 * Setter for ondragstart
	 * @param ondragstart - new value
	 */
	 public void setOndragstart( String  __ondragstart ){
		this._ondragstart = __ondragstart;
	 	 }


	/*
	 * A JavaScript event handler called before drag object.
	 * Getter for ondragstart
	 * @return ondragstart value from local variable or value bindings
	 */
	 public String getOndragstart(  ){
	         if (null != this._ondragstart)
        {
            return this._ondragstart;
        	    }
        ValueBinding vb = getValueBinding("ondragstart");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	    	/*
	 * ignoreDupResponses
	 * Setter for ignoreDupResponses
	 * @param ignoreDupResponses - new value
	 */
	 public void setIgnoreDupResponses( boolean  __ignoreDupResponses ){
		this._ignoreDupResponses = __ignoreDupResponses;
	 		this._ignoreDupResponsesSet = true;
	 	 }


	/*
	 * ignoreDupResponses
	 * Getter for ignoreDupResponses
	 * @return ignoreDupResponses value from local variable or value bindings
	 */
	 public boolean isIgnoreDupResponses(  ){
	 		 if(this._ignoreDupResponsesSet){
			return this._ignoreDupResponses;
		 }
    	ValueBinding vb = getValueBinding("ignoreDupResponses");
    	if (vb != null) {
    	    Boolean value = (Boolean) vb.getValue(getFacesContext());
    	    if (null == value) {
    			return this._ignoreDupResponses;
    	    }
    	    return (value.booleanValue());
    	} else {
    	    return (this._ignoreDupResponses);
    	}
	 	 }
	  
// Component family.
	public static final String COMPONENT_FAMILY = "org.richfaces.DragSupport";

	public String getFamily() {
		return COMPONENT_FAMILY;
	}

	
// Save state
// ----------------------------------------------------- StateHolder Methods


    public Object saveState(FacesContext context) {
        Object values[] = new Object[27];
        values[0] = super.saveState(context);
  	 	          values[1] = _dragValue;
	   	 	
  	 	          values[2] = _ondragend;
	   	 	
    	 	          values[3] = _oncomplete;
	   	 	
   	 	          values[4] = _reRender;
	   	 	
   	        values[5] = new Boolean(_disableDefault);
	   	   values[6] = Boolean.valueOf(_disableDefaultSet);	
	   	 	
  	        values[7] = new Boolean(_bypassUpdates);
	   	   values[8] = Boolean.valueOf(_bypassUpdatesSet);	
	   	 	
  	        values[9] = new Boolean(_limitToList);
	   	   values[10] = Boolean.valueOf(_limitToListSet);	
	   	 	
  	        values[11] = new Boolean(_ajaxSingle);
	   	   values[12] = Boolean.valueOf(_ajaxSingleSet);	
	   	 	
  	 	          values[13] = _onsubmit;
	   	 	
  	 	          values[14] = _dragIndicator;
	   	 	
     	 	          values[15] = saveAttachedState(context, _dragListener );		
	   	 	
  	        values[16] = new Integer(_timeout);
	   	   values[17] = Boolean.valueOf(_timeoutSet);	
	   	 	
   	 	          values[18] = _dragType;
	   	 	
  	 	          values[19] = _status;
	   	 	
   	        values[20] = new Integer(_requestDelay);
	   	   values[21] = Boolean.valueOf(_requestDelaySet);	
	   	 	
  	 	          values[22] = _eventsQueue;
	   	 	
   	 	          values[23] = _data;
	   	 	
   	 	          values[24] = _ondragstart;
	   	 	
   	        values[25] = new Boolean(_ignoreDupResponses);
	   	   values[26] = Boolean.valueOf(_ignoreDupResponsesSet);	
	   	 	
 	  return values;
   }
   

    public void restoreState(FacesContext context, Object state) {
        Object values[] = (Object[]) state;
        super.restoreState(context, values[0]);
  	 	          _dragValue = (Object)values[1] ;
	   	 	
  	 	          _ondragend = (String)values[2] ;
	   	 	
    	 	          _oncomplete = (String)values[3] ;
	   	 	
   	 	          _reRender = (Object)values[4] ;
	   	 	
   	        _disableDefault = ((Boolean)values[5]).booleanValue();
	   	   _disableDefaultSet = ((Boolean)values[6]).booleanValue();	
	   	 	
  	        _bypassUpdates = ((Boolean)values[7]).booleanValue();
	   	   _bypassUpdatesSet = ((Boolean)values[8]).booleanValue();	
	   	 	
  	        _limitToList = ((Boolean)values[9]).booleanValue();
	   	   _limitToListSet = ((Boolean)values[10]).booleanValue();	
	   	 	
  	        _ajaxSingle = ((Boolean)values[11]).booleanValue();
	   	   _ajaxSingleSet = ((Boolean)values[12]).booleanValue();	
	   	 	
  	 	          _onsubmit = (String)values[13] ;
	   	 	
  	 	          _dragIndicator = (String)values[14] ;
	   	 	
     	 	          _dragListener = (MethodBinding)restoreAttachedState(context,values[15] );		
	   	 	
  	        _timeout = ((Integer)values[16]).intValue();
	   	   _timeoutSet = ((Boolean)values[17]).booleanValue();	
	   	 	
   	 	          _dragType = (String)values[18] ;
	   	 	
  	 	          _status = (String)values[19] ;
	   	 	
   	        _requestDelay = ((Integer)values[20]).intValue();
	   	   _requestDelaySet = ((Boolean)values[21]).booleanValue();	
	   	 	
  	 	          _eventsQueue = (String)values[22] ;
	   	 	
   	 	          _data = (Object)values[23] ;
	   	 	
   	 	          _ondragstart = (String)values[24] ;
	   	 	
   	        _ignoreDupResponses = ((Boolean)values[25]).booleanValue();
	   	   _ignoreDupResponsesSet = ((Boolean)values[26]).booleanValue();	
	   	 	
 	
		
	}	
// Utilites

}