/**
 * License Agreement.
 *
 * Ajax4jsf 1.1 - Natural Ajax for Java Server Faces (JSF)
 *
 * Copyright (C) 2007 Exadel, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

package org.richfaces.component.html;

import java.lang.String ;
import org.richfaces.component.UIModalPanel ;

import javax.faces.context.FacesContext;
import javax.faces.el.ValueBinding;

/**
 * Component-Type org.richfaces.ModalPanel
 * Component-Family org.richfaces.ModalPanel
  	 * Renderer-Type org.richfaces.ModalPanelRenderer
  	 * 
 */
 public class HtmlModalPanel extends org.richfaces.component.UIModalPanel {

  public static final String COMPONENT_TYPE = "org.richfaces.ModalPanel";

  /**
   *  Constructor to init default renderers 
   */ 
  public HtmlModalPanel (){
  	  	setRendererType("org.richfaces.ModalPanelRenderer");
  	  }

// Component properties fields
 	/**
	 * width
	 * 
	 */
	 	 private int  _width = 300;		
	/**
	 * Flag indicated what width is set.
	 */
	 private boolean _widthSet = false;	
	 	  	/**
	 * top
	 * 
	 */
	 	 private String  _top = null; /* Default is "auto"*/
	 	  	/**
	 * controlsClass
	 * 
	 */
	 	 private String  _controlsClass = null; /* Default is ""*/
	 	  	/**
	 * moveable
	 * 
	 */
	 	 private boolean  _moveable = true;		
	/**
	 * Flag indicated what moveable is set.
	 */
	 private boolean _moveableSet = false;	
	 	   	/**
	 * headerClass
	 * 
	 */
	 	 private String  _headerClass = null; /* Default is ""*/
	 	  	/**
	 * zindex
	 * 
	 */
	 	 private int  _zindex = 100;		
	/**
	 * Flag indicated what zindex is set.
	 */
	 private boolean _zindexSet = false;	
	 	  	/**
	 * minWidth
	 * 
	 */
	 	 private int  _minWidth = -1;		
	/**
	 * Flag indicated what minWidth is set.
	 */
	 private boolean _minWidthSet = false;	
	 	   	/**
	 * resizeable
	 * 
	 */
	 	 private boolean  _resizeable = true;		
	/**
	 * Flag indicated what resizeable is set.
	 */
	 private boolean _resizeableSet = false;	
	 	  	/**
	 * height
	 * 
	 */
	 	 private int  _height = 200;		
	/**
	 * Flag indicated what height is set.
	 */
	 private boolean _heightSet = false;	
	 	  	/**
	 * left
	 * 
	 */
	 	 private String  _left = null; /* Default is "auto"*/
	 	   	/**
	 * minHeight
	 * 
	 */
	 	 private int  _minHeight = -1;		
	/**
	 * Flag indicated what minHeight is set.
	 */
	 private boolean _minHeightSet = false;	
	 	 
// Getters-setters
 	/*
	 * 
	 * Setter for width
	 * @param width - new value
	 */
	 public void setWidth( int  __width ){
		this._width = __width;
	 		this._widthSet = true;
	 	 }


	/*
	 * 
	 * Getter for width
	 * @return width value from local variable or value bindings
	 */
	 public int getWidth(  ){
	 		 if(this._widthSet){
			return this._width;
		 }
    	ValueBinding vb = getValueBinding("width");
    	if (vb != null) {
    	    Integer value = (Integer) vb.getValue(getFacesContext());
    	    if (null == value) {
    			return this._width;
    	    }
    	    return (value.intValue());
    	} else {
    	    return (this._width);
    	}
	 	 }
	   	/*
	 * 
	 * Setter for top
	 * @param top - new value
	 */
	 public void setTop( String  __top ){
		this._top = __top;
	 	 }


	/*
	 * 
	 * Getter for top
	 * @return top value from local variable or value bindings
	 */
	 public String getTop(  ){
	         if (null != this._top)
        {
            return this._top;
        	    }
        ValueBinding vb = getValueBinding("top");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return "auto";
        }
	 	 }
	   	/*
	 * 
	 * Setter for controlsClass
	 * @param controlsClass - new value
	 */
	 public void setControlsClass( String  __controlsClass ){
		this._controlsClass = __controlsClass;
	 	 }


	/*
	 * 
	 * Getter for controlsClass
	 * @return controlsClass value from local variable or value bindings
	 */
	 public String getControlsClass(  ){
	         if (null != this._controlsClass)
        {
            return this._controlsClass;
        	    }
        ValueBinding vb = getValueBinding("controlsClass");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return "";
        }
	 	 }
	   	/*
	 * 
	 * Setter for moveable
	 * @param moveable - new value
	 */
	 public void setMoveable( boolean  __moveable ){
		this._moveable = __moveable;
	 		this._moveableSet = true;
	 	 }


	/*
	 * 
	 * Getter for moveable
	 * @return moveable value from local variable or value bindings
	 */
	 public boolean isMoveable(  ){
	 		 if(this._moveableSet){
			return this._moveable;
		 }
    	ValueBinding vb = getValueBinding("moveable");
    	if (vb != null) {
    	    Boolean value = (Boolean) vb.getValue(getFacesContext());
    	    if (null == value) {
    			return this._moveable;
    	    }
    	    return (value.booleanValue());
    	} else {
    	    return (this._moveable);
    	}
	 	 }
	    	/*
	 * 
	 * Setter for headerClass
	 * @param headerClass - new value
	 */
	 public void setHeaderClass( String  __headerClass ){
		this._headerClass = __headerClass;
	 	 }


	/*
	 * 
	 * Getter for headerClass
	 * @return headerClass value from local variable or value bindings
	 */
	 public String getHeaderClass(  ){
	         if (null != this._headerClass)
        {
            return this._headerClass;
        	    }
        ValueBinding vb = getValueBinding("headerClass");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return "";
        }
	 	 }
	   	/*
	 * 
	 * Setter for zindex
	 * @param zindex - new value
	 */
	 public void setZindex( int  __zindex ){
		this._zindex = __zindex;
	 		this._zindexSet = true;
	 	 }


	/*
	 * 
	 * Getter for zindex
	 * @return zindex value from local variable or value bindings
	 */
	 public int getZindex(  ){
	 		 if(this._zindexSet){
			return this._zindex;
		 }
    	ValueBinding vb = getValueBinding("zindex");
    	if (vb != null) {
    	    Integer value = (Integer) vb.getValue(getFacesContext());
    	    if (null == value) {
    			return this._zindex;
    	    }
    	    return (value.intValue());
    	} else {
    	    return (this._zindex);
    	}
	 	 }
	   	/*
	 * 
	 * Setter for minWidth
	 * @param minWidth - new value
	 */
	 public void setMinWidth( int  __minWidth ){
		this._minWidth = __minWidth;
	 		this._minWidthSet = true;
	 	 }


	/*
	 * 
	 * Getter for minWidth
	 * @return minWidth value from local variable or value bindings
	 */
	 public int getMinWidth(  ){
	 		 if(this._minWidthSet){
			return this._minWidth;
		 }
    	ValueBinding vb = getValueBinding("minWidth");
    	if (vb != null) {
    	    Integer value = (Integer) vb.getValue(getFacesContext());
    	    if (null == value) {
    			return this._minWidth;
    	    }
    	    return (value.intValue());
    	} else {
    	    return (this._minWidth);
    	}
	 	 }
	    	/*
	 * 
	 * Setter for resizeable
	 * @param resizeable - new value
	 */
	 public void setResizeable( boolean  __resizeable ){
		this._resizeable = __resizeable;
	 		this._resizeableSet = true;
	 	 }


	/*
	 * 
	 * Getter for resizeable
	 * @return resizeable value from local variable or value bindings
	 */
	 public boolean isResizeable(  ){
	 		 if(this._resizeableSet){
			return this._resizeable;
		 }
    	ValueBinding vb = getValueBinding("resizeable");
    	if (vb != null) {
    	    Boolean value = (Boolean) vb.getValue(getFacesContext());
    	    if (null == value) {
    			return this._resizeable;
    	    }
    	    return (value.booleanValue());
    	} else {
    	    return (this._resizeable);
    	}
	 	 }
	   	/*
	 * 
	 * Setter for height
	 * @param height - new value
	 */
	 public void setHeight( int  __height ){
		this._height = __height;
	 		this._heightSet = true;
	 	 }


	/*
	 * 
	 * Getter for height
	 * @return height value from local variable or value bindings
	 */
	 public int getHeight(  ){
	 		 if(this._heightSet){
			return this._height;
		 }
    	ValueBinding vb = getValueBinding("height");
    	if (vb != null) {
    	    Integer value = (Integer) vb.getValue(getFacesContext());
    	    if (null == value) {
    			return this._height;
    	    }
    	    return (value.intValue());
    	} else {
    	    return (this._height);
    	}
	 	 }
	   	/*
	 * 
	 * Setter for left
	 * @param left - new value
	 */
	 public void setLeft( String  __left ){
		this._left = __left;
	 	 }


	/*
	 * 
	 * Getter for left
	 * @return left value from local variable or value bindings
	 */
	 public String getLeft(  ){
	         if (null != this._left)
        {
            return this._left;
        	    }
        ValueBinding vb = getValueBinding("left");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return "auto";
        }
	 	 }
	    	/*
	 * 
	 * Setter for minHeight
	 * @param minHeight - new value
	 */
	 public void setMinHeight( int  __minHeight ){
		this._minHeight = __minHeight;
	 		this._minHeightSet = true;
	 	 }


	/*
	 * 
	 * Getter for minHeight
	 * @return minHeight value from local variable or value bindings
	 */
	 public int getMinHeight(  ){
	 		 if(this._minHeightSet){
			return this._minHeight;
		 }
    	ValueBinding vb = getValueBinding("minHeight");
    	if (vb != null) {
    	    Integer value = (Integer) vb.getValue(getFacesContext());
    	    if (null == value) {
    			return this._minHeight;
    	    }
    	    return (value.intValue());
    	} else {
    	    return (this._minHeight);
    	}
	 	 }
	  
// Component family.
	public static final String COMPONENT_FAMILY = "org.richfaces.ModalPanel";

	public String getFamily() {
		return COMPONENT_FAMILY;
	}

	
// Save state
// ----------------------------------------------------- StateHolder Methods


    public Object saveState(FacesContext context) {
        Object values[] = new Object[19];
        values[0] = super.saveState(context);
 	        values[1] = new Integer(_width);
	   	   values[2] = Boolean.valueOf(_widthSet);	
	   	 	
  	 	          values[3] = _top;
	   	 	
  	 	          values[4] = _controlsClass;
	   	 	
  	        values[5] = new Boolean(_moveable);
	   	   values[6] = Boolean.valueOf(_moveableSet);	
	   	 	
   	 	          values[7] = _headerClass;
	   	 	
  	        values[8] = new Integer(_zindex);
	   	   values[9] = Boolean.valueOf(_zindexSet);	
	   	 	
  	        values[10] = new Integer(_minWidth);
	   	   values[11] = Boolean.valueOf(_minWidthSet);	
	   	 	
   	        values[12] = new Boolean(_resizeable);
	   	   values[13] = Boolean.valueOf(_resizeableSet);	
	   	 	
  	        values[14] = new Integer(_height);
	   	   values[15] = Boolean.valueOf(_heightSet);	
	   	 	
  	 	          values[16] = _left;
	   	 	
   	        values[17] = new Integer(_minHeight);
	   	   values[18] = Boolean.valueOf(_minHeightSet);	
	   	 	
 	  return values;
   }
   

    public void restoreState(FacesContext context, Object state) {
        Object values[] = (Object[]) state;
        super.restoreState(context, values[0]);
 	        _width = ((Integer)values[1]).intValue();
	   	   _widthSet = ((Boolean)values[2]).booleanValue();	
	   	 	
  	 	          _top = (String)values[3] ;
	   	 	
  	 	          _controlsClass = (String)values[4] ;
	   	 	
  	        _moveable = ((Boolean)values[5]).booleanValue();
	   	   _moveableSet = ((Boolean)values[6]).booleanValue();	
	   	 	
   	 	          _headerClass = (String)values[7] ;
	   	 	
  	        _zindex = ((Integer)values[8]).intValue();
	   	   _zindexSet = ((Boolean)values[9]).booleanValue();	
	   	 	
  	        _minWidth = ((Integer)values[10]).intValue();
	   	   _minWidthSet = ((Boolean)values[11]).booleanValue();	
	   	 	
   	        _resizeable = ((Boolean)values[12]).booleanValue();
	   	   _resizeableSet = ((Boolean)values[13]).booleanValue();	
	   	 	
  	        _height = ((Integer)values[14]).intValue();
	   	   _heightSet = ((Boolean)values[15]).booleanValue();	
	   	 	
  	 	          _left = (String)values[16] ;
	   	 	
   	        _minHeight = ((Integer)values[17]).intValue();
	   	   _minHeightSet = ((Boolean)values[18]).booleanValue();	
	   	 	
 	
		
	}	
// Utilites

}