/**
 * License Agreement.
 *
 * Ajax4jsf 1.1 - Natural Ajax for Java Server Faces (JSF)
 *
 * Copyright (C) 2007 Exadel, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

package org.richfaces.component.html;

import java.lang.String ;
import org.richfaces.component.UIPanelBarItem ;

import javax.faces.context.FacesContext;
import javax.faces.el.ValueBinding;

/**
 * Component-Type org.richfaces.PanelBarItem
 * Component-Family org.richfaces.PanelBarItem
  	 * Renderer-Type org.richfaces.PanelBarItemRenderer
  	 * Slider Panel Item
 */
 public class HtmlPanelBarItem extends org.richfaces.component.UIPanelBarItem {

  public static final String COMPONENT_TYPE = "org.richfaces.PanelBarItem";

  /**
   *  Constructor to init default renderers 
   */ 
  public HtmlPanelBarItem (){
  	  	setRendererType("org.richfaces.PanelBarItemRenderer");
  	  }

// Component properties fields
 	/**
	 * contentClass
	 * The component content style class
	 */
	 	 private String  _contentClass = null; /* Default is null*/
	 	  	/**
	 * headerStyle
	 * The component header style
	 */
	 	 private String  _headerStyle = null; /* Default is ""*/
	 	  	/**
	 * contentStyle
	 * The component content style
	 */
	 	 private String  _contentStyle = null; /* Default is ""*/
	 	  	/**
	 * label
	 * Label text appears on a panel item header
	 */
	 	 private String  _label = null; /* Default is "auto generated label"*/
	 	  	/**
	 * expanded
	 * Notifies that an element has to be expanded
	 */
	 	 private String  _expanded = null; /* Default is "false"*/
	 	  	/**
	 * headerClass
	 * The component header style class
	 */
	 	 private String  _headerClass = null; /* Default is null*/
	 	     
// Getters-setters
 	/*
	 * The component content style class
	 * Setter for contentClass
	 * @param contentClass - new value
	 */
	 public void setContentClass( String  __contentClass ){
		this._contentClass = __contentClass;
	 	 }


	/*
	 * The component content style class
	 * Getter for contentClass
	 * @return contentClass value from local variable or value bindings
	 */
	 public String getContentClass(  ){
	         if (null != this._contentClass)
        {
            return this._contentClass;
        	    }
        ValueBinding vb = getValueBinding("contentClass");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	   	/*
	 * The component header style
	 * Setter for headerStyle
	 * @param headerStyle - new value
	 */
	 public void setHeaderStyle( String  __headerStyle ){
		this._headerStyle = __headerStyle;
	 	 }


	/*
	 * The component header style
	 * Getter for headerStyle
	 * @return headerStyle value from local variable or value bindings
	 */
	 public String getHeaderStyle(  ){
	         if (null != this._headerStyle)
        {
            return this._headerStyle;
        	    }
        ValueBinding vb = getValueBinding("headerStyle");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return "";
        }
	 	 }
	   	/*
	 * The component content style
	 * Setter for contentStyle
	 * @param contentStyle - new value
	 */
	 public void setContentStyle( String  __contentStyle ){
		this._contentStyle = __contentStyle;
	 	 }


	/*
	 * The component content style
	 * Getter for contentStyle
	 * @return contentStyle value from local variable or value bindings
	 */
	 public String getContentStyle(  ){
	         if (null != this._contentStyle)
        {
            return this._contentStyle;
        	    }
        ValueBinding vb = getValueBinding("contentStyle");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return "";
        }
	 	 }
	   	/*
	 * Label text appears on a panel item header
	 * Setter for label
	 * @param label - new value
	 */
	 public void setLabel( String  __label ){
		this._label = __label;
	 	 }


	/*
	 * Label text appears on a panel item header
	 * Getter for label
	 * @return label value from local variable or value bindings
	 */
	 public String getLabel(  ){
	         if (null != this._label)
        {
            return this._label;
        	    }
        ValueBinding vb = getValueBinding("label");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return "auto generated label";
        }
	 	 }
	   	/*
	 * Notifies that an element has to be expanded
	 * Setter for expanded
	 * @param expanded - new value
	 */
	 public void setExpanded( String  __expanded ){
		this._expanded = __expanded;
	 	 }


	/*
	 * Notifies that an element has to be expanded
	 * Getter for expanded
	 * @return expanded value from local variable or value bindings
	 */
	 public String getExpanded(  ){
	         if (null != this._expanded)
        {
            return this._expanded;
        	    }
        ValueBinding vb = getValueBinding("expanded");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return "false";
        }
	 	 }
	   	/*
	 * The component header style class
	 * Setter for headerClass
	 * @param headerClass - new value
	 */
	 public void setHeaderClass( String  __headerClass ){
		this._headerClass = __headerClass;
	 	 }


	/*
	 * The component header style class
	 * Getter for headerClass
	 * @return headerClass value from local variable or value bindings
	 */
	 public String getHeaderClass(  ){
	         if (null != this._headerClass)
        {
            return this._headerClass;
        	    }
        ValueBinding vb = getValueBinding("headerClass");
        if (null != vb){
            return (String)vb.getValue(getFacesContext());
		        } else {
            return null;
        }
	 	 }
	      
// Component family.
	public static final String COMPONENT_FAMILY = "org.richfaces.PanelBarItem";

	public String getFamily() {
		return COMPONENT_FAMILY;
	}

	
// Save state
// ----------------------------------------------------- StateHolder Methods


    public Object saveState(FacesContext context) {
        Object values[] = new Object[7];
        values[0] = super.saveState(context);
 	 	          values[1] = _contentClass;
	   	 	
  	 	          values[2] = _headerStyle;
	   	 	
  	 	          values[3] = _contentStyle;
	   	 	
  	 	          values[4] = _label;
	   	 	
  	 	          values[5] = _expanded;
	   	 	
  	 	          values[6] = _headerClass;
	   	 	
     	  return values;
   }
   

    public void restoreState(FacesContext context, Object state) {
        Object values[] = (Object[]) state;
        super.restoreState(context, values[0]);
 	 	          _contentClass = (String)values[1] ;
	   	 	
  	 	          _headerStyle = (String)values[2] ;
	   	 	
  	 	          _contentStyle = (String)values[3] ;
	   	 	
  	 	          _label = (String)values[4] ;
	   	 	
  	 	          _expanded = (String)values[5] ;
	   	 	
  	 	          _headerClass = (String)values[6] ;
	   	 	
     	
		
	}	
// Utilites

}