/**
 * License Agreement.
 *
 *  JBoss RichFaces 3.0 - Ajax4jsf Component Library
 *
 * Copyright (C) 2007  Exadel, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

package org.richfaces.renderkit.html;

import org.ajax4jsf.framework.resource.InternetResource;
import org.richfaces.component.UIDragSupport;
import org.richfaces.renderkit.CompositeRenderer;
import org.richfaces.renderkit.DraggableRendererContributor;

/**
 * @author Nick Belaevski - nbelaevski@exadel.com
 * created 23.02.2007
 * 
 */
public class DragSupportRenderer extends CompositeRenderer {

	public DragSupportRenderer() {
		super();

		addContributor(DraggableRendererContributor.getInstance());
	}

	/* (non-Javadoc)
	 * @see org.ajax4jsf.framework.renderer.RendererBase#getComponentClass()
	 */
	protected Class getComponentClass() {
		return UIDragSupport.class;
	}

	protected InternetResource[] getScripts() {
		InternetResource[] resources = super.getScripts();
		InternetResource[] result = new InternetResource[resources.length + 1];
		System.arraycopy(resources, 0, result, 0, resources.length);
		result[result.length - 1] = getResource("/org/richfaces/renderkit/html/scripts/simple-draggable.js");
		return result;
	}
}
