/**
 * License Agreement.
 *
 *  JBoss RichFaces 3.0 - Ajax4jsf Component Library
 *
 * Copyright (C) 2007  Exadel, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

package org.richfaces.taglib;

import java.io.IOException;

import javax.el.ELException;
import javax.faces.FacesException;
import javax.faces.component.UIComponent;
import javax.faces.component.UIComponentBase;

import org.ajax4jsf.taglib.html.facelets.AjaxSupportHandler;

import com.sun.facelets.FaceletContext;
import com.sun.facelets.FaceletException;
import com.sun.facelets.tag.TagHandler;
import com.sun.facelets.tag.jsf.ComponentConfig;

/**
 * @author Nick - mailto:nbelaevski@exadel.com
 * created 24.02.2007
 * 
 * Higher abstraction of {@link AjaxSupportHandler}
 */
public abstract class EventInjectionSupportHandler extends TagHandler {

	private TagHandler baseHandler;
	
	private static final class EventInjectionSupportFacet extends UIComponentBase {

		public String getFamily() {
			return null;
		}
	}

	protected abstract String getEventName();

	public EventInjectionSupportHandler(ComponentConfig componentConfig, TagHandler tagHandler) {
		super(componentConfig);

		this.baseHandler = tagHandler;
	}

	public void apply(FaceletContext faceletContext, UIComponent parent)
			throws IOException, FacesException, FaceletException, ELException {
		String eventName = getEventName();
        // our id
//        String id = ctx.generateUniqueId(this.tagId);
		EventInjectionSupportFacet facet = new EventInjectionSupportFacet();
        // Find facet for support component
        String facetName = EventInjectionSupportHandler.class.getName() + "_" + eventName;
        UIComponent c = parent.getFacet(facetName);
        if (null != c) {
			parent.getFacets().remove(facetName);
			facet.getChildren().add(c);
		}
        this.baseHandler.apply(faceletContext, facet);

        c = (UIComponent) facet.getChildren().get(0);
        parent.getFacets().put(facetName, c);
        // Fix for possible incompabilites in different frameworks.
//        c.setParentProperties(parent);

	}

}
