package org.richfaces.taglib;

import java.lang.String ;
import java.lang.Object ;
import javax.faces.el.MethodBinding ;
import org.ajax4jsf.ajax.repeat.DataComponentState ;
import org.richfaces.component.preserve.TreeDataLocator ;
import org.richfaces.taglib.TreeListenersTagHandler ;
import javax.faces.component.UIComponent;
import org.richfaces.component.html.HtmlTree;
import com.sun.facelets.tag.jsf.ComponentHandler;
import com.sun.facelets.tag.jsf.ComponentConfig;

import com.sun.facelets.*;
import com.sun.facelets.el.*;
import com.sun.facelets.tag.*;
/**
 * @author shura (latest modification by $Author: ishabalov $)
 * @version $Revision: 1.1.2.4 $ $Date: 2007/02/20 20:58:03 $
 *
 */
public class TreeTagHandler extends org.richfaces.taglib.TreeListenersTagHandler {


  private static final TreeTagHandlerMetaRule metaRule = new TreeTagHandlerMetaRule();


  
  public TreeTagHandler(ComponentConfig config) 
  {
    super(config);
  }
// Metarule
  protected MetaRuleset createMetaRuleset(Class type)
  {
    MetaRuleset m = super.createMetaRuleset(type);
	m.addRule(metaRule);
	return m;
  }

  	/**
	 * @author shura (latest modification by $Author: ishabalov $)
	 * @version $Revision: 1.1.2.4 $ $Date: 2007/02/20 20:58:03 $
	 *
	 */
	static class TreeTagHandlerMetaRule extends MetaRule{

		/* (non-Javadoc)
		 * @see com.sun.facelets.tag.MetaRule#applyRule(java.lang.String, com.sun.facelets.tag.TagAttribute, com.sun.facelets.tag.MetadataTarget)
		 */
		public Metadata applyRule(String name, TagAttribute attribute, MetadataTarget meta) {
	        if (meta.isTargetInstanceOf(HtmlTree.class)) {
				 		  		 				 		  		 				 		  		 				 				 		  		 				 		  		 				 		  		 				 				 		  		 				 		  		 				 		  		 				 				 		  		 				 		  		 				 		  		 				 		  		 				 		  	            if ("dragListener".equals(name)) {
	                    return new dragListenerMapper(attribute);
	            }

		  		 				 		  		 				 		  	            if ("nodeSelectListener".equals(name)) {
	                    return new nodeSelectListenerMapper(attribute);
	            }

		  		 				 		  		 				 		  	            if ("dropListener".equals(name)) {
	                    return new dropListenerMapper(attribute);
	            }

		  		 				 		  		 				 		  		 				 		  		 				 		  		 				 				 		  		 				 				 		  		 				 		  		 				 		  		 				 				 		  		 				 				 		  		 				 				 		  		 				 				 		  		 				 		  		 				 				 		  		 				 		  		 				 		  		 				 		  		 				 		  	            if ("changeExpandListener".equals(name)) {
	                    return new changeExpandListenerMapper(attribute);
	            }

		  		 				 		  		 				 		  		 				 				 				 		  		 				 		  		 				 		  		 				 				 		  		 				 		  		 				 				 				 		  		 				 			        }
			return null;
		}

	}


    
    
     
    
    
     
    
    
     
    
    
    
    
  	
	static class dragListenerMapper extends Metadata {

		private static final Class[] SIGNATURE = new Class[] {org.ajax4jsf.dnd.event.DragEvent.class};

		private final TagAttribute _action;
		/**
		 * @param attribute
		 */
		public dragListenerMapper(TagAttribute attribute) {
			_action = attribute;
		}

		/* (non-Javadoc)
		 * @see com.sun.facelets.tag.Metadata#applyMetadata(com.sun.facelets.FaceletContext, java.lang.Object)
		 */
		public void applyMetadata(FaceletContext ctx, Object instance) {
            ((HtmlTree) instance)
            .setDragListener(new LegacyMethodBinding(this._action
                    .getMethodExpression(ctx, null,
                            SIGNATURE)));
		}

	}
	  
    
  	
	static class nodeSelectListenerMapper extends Metadata {

		private static final Class[] SIGNATURE = new Class[] {org.richfaces.component.events.NodeSelectedEvent.class};

		private final TagAttribute _action;
		/**
		 * @param attribute
		 */
		public nodeSelectListenerMapper(TagAttribute attribute) {
			_action = attribute;
		}

		/* (non-Javadoc)
		 * @see com.sun.facelets.tag.Metadata#applyMetadata(com.sun.facelets.FaceletContext, java.lang.Object)
		 */
		public void applyMetadata(FaceletContext ctx, Object instance) {
            ((HtmlTree) instance)
            .setNodeSelectListener(new LegacyMethodBinding(this._action
                    .getMethodExpression(ctx, null,
                            SIGNATURE)));
		}

	}
	  
    
  	
	static class dropListenerMapper extends Metadata {

		private static final Class[] SIGNATURE = new Class[] {org.ajax4jsf.dnd.event.DropEvent.class};

		private final TagAttribute _action;
		/**
		 * @param attribute
		 */
		public dropListenerMapper(TagAttribute attribute) {
			_action = attribute;
		}

		/* (non-Javadoc)
		 * @see com.sun.facelets.tag.Metadata#applyMetadata(com.sun.facelets.FaceletContext, java.lang.Object)
		 */
		public void applyMetadata(FaceletContext ctx, Object instance) {
            ((HtmlTree) instance)
            .setDropListener(new LegacyMethodBinding(this._action
                    .getMethodExpression(ctx, null,
                            SIGNATURE)));
		}

	}
	  
    
    
    
     
     
    
    
     
     
     
     
    
     
    
    
    
    
  	
	static class changeExpandListenerMapper extends Metadata {

		private static final Class[] SIGNATURE = new Class[] {org.richfaces.component.events.NodeExpandedEvent.class};

		private final TagAttribute _action;
		/**
		 * @param attribute
		 */
		public changeExpandListenerMapper(TagAttribute attribute) {
			_action = attribute;
		}

		/* (non-Javadoc)
		 * @see com.sun.facelets.tag.Metadata#applyMetadata(com.sun.facelets.FaceletContext, java.lang.Object)
		 */
		public void applyMetadata(FaceletContext ctx, Object instance) {
            ((HtmlTree) instance)
            .setChangeExpandListener(new LegacyMethodBinding(this._action
                    .getMethodExpression(ctx, null,
                            SIGNATURE)));
		}

	}
	  
    
      
    
    
     
    
      
     }
